/**
 * @author SamsamTS
 */
import com.samsamts.Events.Event;
import com.samsamts.Input.KeyEventArgs;

class com.samsamts.Input.KeyboardDevice
{
	//{ Author properties
	public static var className:String = "KeyboardDevice";
	public static var classPackage:String = "com.samsamts.Input";
	public static var version:String = "1.0.0";
	public static var author:String = "SamsamTS";
	public static var link:String = "http://www.samsamts.com/blog/";
	//}
	
	//{ Events
	public static var OnKeyDown:Event = new Event();
	public static var OnKeyUp:Event = new Event();
	//}

	public function toString():String
	{
		return "[KeyboardDevice]";
	}

	//{ Private
	private static var $instance = new KeyboardDevice();

	private var m_arrKeys:Array;

	private function KeyboardDevice()
	{
		m_arrKeys = new Array();
		Key.addListener(this);
	}

	private function onKeyDown()
	{
		m_arrKeys.unshift(Key.getCode());
		OnKeyDown.Trigger(this, new KeyEventArgs(Key.getCode(),m_arrKeys.splice()));
	}
	
	private function onKeyUp()
	{
		for(var i:Number = 0; i<m_arrKeys.length; i++)
		{
			if(!Key.isDown(m_arrKeys[i]))
			{
				m_arrKeys.splice(i,1);
				break;
			}			
		}
		OnKeyUp.Trigger(this, new KeyEventArgs(Key.getCode(),m_arrKeys.splice()));
	}
	//}
}