/**
 * @author SamsamTS
 */
import com.samsamts.Events.EventWrapper;

class com.samsamts.Input.MouseDevice
{
	//{ Author properties
	public static var className:String = "MouseDevice";
	public static var classPackage:String = "com.samsamts.Input";
	public static var version:String = "1.0.0";
	public static var author:String = "SamsamTS";
	public static var link:String = "http://www.samsamts.com/blog/";
	//}
	
	//{ Events
	public static var OnMouseMove:EventWrapper	= null;
	public static var OnMouseUp:EventWrapper	= null;
	public static var OnMouseDown:EventWrapper	= null;
	public static var OnMouseWheel:EventWrapper	= null;
	//}
	
	//{ Public
	public function toString():String
	{
		return "[MouseDevice]";
	}
	//}

	//{ private
	private static var $instance:MouseDevice = new MouseDevice();

	private function MouseDevice()
	{
		Mouse.addListener(this);
		OnMouseMove		= new EventWrapper(this, "onMouseMove");
		OnMouseUp		= new EventWrapper(this, "onMouseUp");
		OnMouseDown		= new EventWrapper(this, "onMouseDown");
		OnMouseWheel	= new EventWrapper(this, "onMouseWheel");
	}
	//}
}